diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy-state-helper.h ns-3.42/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.41/src/wifi/model/wifi-phy-state-helper.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy-state-helper.h	2024-05-29 15:29:47.212073800 -0700
@@ -20,6 +20,7 @@
 #ifndef WIFI_PHY_STATE_HELPER_H
 #define WIFI_PHY_STATE_HELPER_H
 
+#include "phy-entity.h"
 #include "wifi-phy-common.h"
 #include "wifi-phy-state.h"
 #include "wifi-ppdu.h"
@@ -29,6 +30,7 @@
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
 
+#include <algorithm>
 #include <list>
 #include <memory>
 #include <vector>
@@ -170,6 +172,12 @@
     Time GetLastRxEndTime() const;
 
     /**
+     * \param states a set of PHY states
+     * \return the last time the PHY has been in any of the given states
+     */
+    Time GetLastTime(std::initializer_list<WifiPhyState> states) const;
+
+    /**
      * Switch state to TX for the given duration.
      *
      * \param txDuration the duration of the PPDU to transmit
@@ -224,6 +232,21 @@
      * \param snr the SNR of the received PSDU in linear scale
      */
     void NotifyRxPsduFailed(Ptr<const WifiPsdu> psdu, double snr);
+
+    /**
+     * Handle the outcome of a reception of a PPDU.
+     *
+     * \param ppdu the received PPDU
+     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * \param txVector TXVECTOR of the PSDU
+     * \param staId the station ID of the PSDU (only used for MU)
+     * \param statusPerMpdu reception status per MPDU
+     */
+    void NotifyRxPpduOutcome(Ptr<const WifiPpdu> ppdu,
+                             RxSignalInfo rxSignalInfo,
+                             const WifiTxVector& txVector,
+                             uint16_t staId,
+                             const std::vector<bool>& statusPerMpdu);
     /**
      * Switch from RX after the reception was successful.
      */
@@ -291,6 +314,22 @@
                                        WifiPreamble preamble);
 
     /**
+     * TracedCallback signature for the outcome of a received packet.
+     *
+     * \param [in] psdu The received PSDU (Physical Layer Service Data Unit).
+     * \param [in] signalInfo Information about the received signal, including its power and other
+     * characteristics.
+     * \param [in] txVector The transmission vector used for the packet, detailing
+     * the transmission parameters.
+     * \param [in] outcomes A vector of boolean values indicating the
+     * success or failure of receiving individual MPDUs within the PSDU.
+     */
+    typedef void (*RxOutcomeTracedCallback)(Ptr<const WifiPsdu> psdu,
+                                            RxSignalInfo signalInfo,
+                                            const WifiTxVector& txVector,
+                                            const std::vector<bool>& outcomes);
+
+    /**
      * TracedCallback signature for receive end error event.
      *
      * \param [in] packet       The received packet.
@@ -352,16 +391,22 @@
     Time m_endRx;                   ///< end receive
     Time m_endCcaBusy;              ///< end CCA busy
     Time m_endSwitching;            ///< end switching
+    Time m_endSleep;                ///< end sleep
+    Time m_endOff;                  ///< end off
+    Time m_endIdle;                 ///< end idle
     Time m_startTx;                 ///< start transmit
     Time m_startRx;                 ///< start receive
     Time m_startCcaBusy;            ///< start CCA busy
     Time m_startSwitching;          ///< start switching
     Time m_startSleep;              ///< start sleep
+    Time m_startOff;                ///< start off
     Time m_previousStateChangeTime; ///< previous state change time
 
     Listeners m_listeners; ///< listeners
     TracedCallback<Ptr<const Packet>, double, WifiMode, WifiPreamble>
-        m_rxOkTrace;                                          ///< receive OK trace callback
+        m_rxOkTrace; ///< receive OK trace callback
+    TracedCallback<Ptr<const WifiPpdu>, RxSignalInfo, const WifiTxVector&, const std::vector<bool>&>
+        m_rxOutcomeTrace;                                     ///< receive OK trace callback
     TracedCallback<Ptr<const Packet>, double> m_rxErrorTrace; ///< receive error trace callback
     TracedCallback<Ptr<const Packet>, WifiMode, WifiPreamble, uint8_t>
         m_txTrace;                     ///< transmit trace callback
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-protection.cc ns-3.42/src/wifi/model/wifi-protection.cc
--- ns-3.41/src/wifi/model/wifi-protection.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-protection.cc	2024-05-29 15:29:47.212073800 -0700
@@ -29,8 +29,7 @@
  */
 
 WifiProtection::WifiProtection(Method m)
-    : method(m),
-      protectionTime(Time::Min()) // uninitialized
+    : method(m)
 {
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-protection.h ns-3.42/src/wifi/model/wifi-protection.h
--- ns-3.41/src/wifi/model/wifi-protection.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-protection.h	2024-05-29 15:29:47.212073800 -0700
@@ -26,6 +26,7 @@
 #include "ns3/nstime.h"
 
 #include <memory>
+#include <optional>
 
 namespace ns3
 {
@@ -70,8 +71,8 @@
      */
     virtual void Print(std::ostream& os) const = 0;
 
-    const Method method; //!< protection method
-    Time protectionTime; //!< time required by the protection method
+    const Method method;                //!< protection method
+    std::optional<Time> protectionTime; //!< time required by the protection method
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-psdu.cc ns-3.42/src/wifi/model/wifi-psdu.cc
--- ns-3.41/src/wifi/model/wifi-psdu.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-psdu.cc	2024-05-29 15:29:47.212073800 -0700
@@ -192,7 +192,7 @@
 WifiPsdu::GetAckPolicyForTid(uint8_t tid) const
 {
     NS_LOG_FUNCTION(this << +tid);
-    WifiMacHeader::QosAckPolicy policy;
+    WifiMacHeader::QosAckPolicy policy{WifiMacHeader::NORMAL_ACK};
     auto it = m_mpduList.begin();
     bool found = false;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-radio-energy-model.cc ns-3.42/src/wifi/model/wifi-radio-energy-model.cc
--- ns-3.41/src/wifi/model/wifi-radio-energy-model.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-radio-energy-model.cc	2024-05-29 15:29:47.212073800 -0700
@@ -114,7 +114,7 @@
 }
 
 void
-WifiRadioEnergyModel::SetEnergySource(const Ptr<EnergySource> source)
+WifiRadioEnergyModel::SetEnergySource(const Ptr<energy::EnergySource> source)
 {
     NS_LOG_FUNCTION(this << source);
     NS_ASSERT(source);
@@ -124,7 +124,7 @@
     m_switchToOffEvent = Simulator::Schedule(durationToOff,
                                              &WifiRadioEnergyModel::ChangeState,
                                              this,
-                                             WifiPhyState::OFF);
+                                             static_cast<int>(WifiPhyState::OFF));
 }
 
 double
@@ -274,7 +274,7 @@
 }
 
 Time
-WifiRadioEnergyModel::GetMaximumTimeInState(int state) const
+WifiRadioEnergyModel::GetMaximumTimeInState(WifiPhyState state) const
 {
     if (state == WifiPhyState::OFF)
     {
@@ -289,25 +289,26 @@
 void
 WifiRadioEnergyModel::ChangeState(int newState)
 {
-    NS_LOG_FUNCTION(this << newState);
+    WifiPhyState newPhyState{newState};
+    NS_LOG_FUNCTION(this << newPhyState);
 
     m_nPendingChangeState++;
 
-    if (m_nPendingChangeState > 1 && newState == WifiPhyState::OFF)
+    if (m_nPendingChangeState > 1 && newPhyState == WifiPhyState::OFF)
     {
-        SetWifiRadioState((WifiPhyState)newState);
+        SetWifiRadioState(newPhyState);
         m_nPendingChangeState--;
         return;
     }
 
-    if (newState != WifiPhyState::OFF)
+    if (newPhyState != WifiPhyState::OFF)
     {
         m_switchToOffEvent.Cancel();
-        Time durationToOff = GetMaximumTimeInState(newState);
+        Time durationToOff = GetMaximumTimeInState(newPhyState);
         m_switchToOffEvent = Simulator::Schedule(durationToOff,
                                                  &WifiRadioEnergyModel::ChangeState,
                                                  this,
-                                                 WifiPhyState::OFF);
+                                                 static_cast<int>(WifiPhyState::OFF));
     }
 
     Time duration = Simulator::Now() - m_lastUpdateTime;
@@ -337,7 +338,7 @@
     if (m_nPendingChangeState <= 1 && m_currentState != WifiPhyState::OFF)
     {
         // update current state & last update time stamp
-        SetWifiRadioState((WifiPhyState)newState);
+        SetWifiRadioState(newPhyState);
 
         // some debug message
         NS_LOG_DEBUG("WifiRadioEnergyModel:Total energy consumption is " << m_totalEnergyConsumption
@@ -383,7 +384,7 @@
         m_switchToOffEvent = Simulator::Schedule(durationToOff,
                                                  &WifiRadioEnergyModel::ChangeState,
                                                  this,
-                                                 WifiPhyState::OFF);
+                                                 static_cast<int>(WifiPhyState::OFF));
     }
 }
 
@@ -407,7 +408,7 @@
 }
 
 double
-WifiRadioEnergyModel::GetStateA(int state) const
+WifiRadioEnergyModel::GetStateA(WifiPhyState state) const
 {
     switch (state)
     {
@@ -485,7 +486,7 @@
 
 void
 WifiRadioEnergyModelPhyListener::SetChangeStateCallback(
-    DeviceEnergyModel::ChangeStateCallback callback)
+    energy::DeviceEnergyModel::ChangeStateCallback callback)
 {
     NS_LOG_FUNCTION(this << &callback);
     NS_ASSERT(!callback.IsNull());
@@ -508,7 +509,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::RX);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::RX));
     m_switchToIdleEvent.Cancel();
 }
 
@@ -520,7 +521,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::IDLE);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::IDLE));
 }
 
 void
@@ -531,7 +532,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::IDLE);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::IDLE));
 }
 
 void
@@ -547,7 +548,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::TX);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::TX));
     // schedule changing state back to IDLE after TX duration
     m_switchToIdleEvent.Cancel();
     m_switchToIdleEvent =
@@ -564,7 +565,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::CCA_BUSY);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::CCA_BUSY));
     // schedule changing state back to IDLE after CCA_BUSY duration
     m_switchToIdleEvent.Cancel();
     m_switchToIdleEvent =
@@ -579,7 +580,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::SWITCHING);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::SWITCHING));
     // schedule changing state back to IDLE after CCA_BUSY duration
     m_switchToIdleEvent.Cancel();
     m_switchToIdleEvent =
@@ -594,7 +595,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::SLEEP);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::SLEEP));
     m_switchToIdleEvent.Cancel();
 }
 
@@ -606,7 +607,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::IDLE);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::IDLE));
 }
 
 void
@@ -617,7 +618,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::OFF);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::OFF));
     m_switchToIdleEvent.Cancel();
 }
 
@@ -629,7 +630,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::IDLE);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::IDLE));
 }
 
 void
@@ -640,7 +641,7 @@
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
     }
-    m_changeStateCallback(WifiPhyState::IDLE);
+    m_changeStateCallback(static_cast<int>(WifiPhyState::IDLE));
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-radio-energy-model.h ns-3.42/src/wifi/model/wifi-radio-energy-model.h
--- ns-3.41/src/wifi/model/wifi-radio-energy-model.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-radio-energy-model.h	2024-05-29 15:29:47.212073800 -0700
@@ -56,7 +56,7 @@
      *
      * \param callback Change state callback.
      */
-    void SetChangeStateCallback(DeviceEnergyModel::ChangeStateCallback callback);
+    void SetChangeStateCallback(energy::DeviceEnergyModel::ChangeStateCallback callback);
 
     /**
      * \brief Sets the update TX current callback.
@@ -88,7 +88,7 @@
      * Change state callback used to notify the WifiRadioEnergyModel of a state
      * change.
      */
-    DeviceEnergyModel::ChangeStateCallback m_changeStateCallback;
+    energy::DeviceEnergyModel::ChangeStateCallback m_changeStateCallback;
 
     /**
      * Callback used to update the TX current stored in WifiRadioEnergyModel based on
@@ -148,7 +148,7 @@
  * transmit power can also be achieved through a wifi TX current model.
  *
  */
-class WifiRadioEnergyModel : public DeviceEnergyModel
+class WifiRadioEnergyModel : public energy::DeviceEnergyModel
 {
   public:
     /**
@@ -176,7 +176,7 @@
      *
      * Implements DeviceEnergyModel::SetEnergySource.
      */
-    void SetEnergySource(const Ptr<EnergySource> source) override;
+    void SetEnergySource(const Ptr<energy::EnergySource> source) override;
 
     /**
      * \returns Total energy consumption of the wifi device in watts.
@@ -305,7 +305,7 @@
      *
      * \returns the time the radio can stay in that state based on the remaining energy.
      */
-    Time GetMaximumTimeInState(int state) const;
+    Time GetMaximumTimeInState(WifiPhyState state) const;
 
     /**
      * \brief Handles energy depletion.
@@ -340,7 +340,7 @@
      * \param state the wifi state
      * \returns draw of device in Amperes, at given state.
      */
-    double GetStateA(int state) const;
+    double GetStateA(WifiPhyState state) const;
 
     /**
      * \returns Current draw of device in Amperes, at current state.
@@ -357,7 +357,7 @@
      */
     void SetWifiRadioState(const WifiPhyState state);
 
-    Ptr<EnergySource> m_source; ///< energy source
+    Ptr<energy::EnergySource> m_source; ///< energy source
 
     // Member variables for current draw in different radio modes.
     double m_txCurrentA;                      ///< transmit current in Amperes
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-remote-station-manager.cc ns-3.42/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.41/src/wifi/model/wifi-remote-station-manager.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-remote-station-manager.cc	2024-05-29 15:29:47.212073800 -0700
@@ -26,6 +26,7 @@
 #include "wifi-mpdu.h"
 #include "wifi-net-device.h"
 #include "wifi-phy.h"
+#include "wifi-tx-parameters.h"
 
 #include "ns3/boolean.h"
 #include "ns3/eht-configuration.h"
@@ -74,6 +75,13 @@
                           UintegerValue(4692480),
                           MakeUintegerAccessor(&WifiRemoteStationManager::SetRtsCtsThreshold),
                           MakeUintegerChecker<uint32_t>(0, 4692480))
+            .AddAttribute("RtsCtsTxDurationThresh",
+                          "If this threshold is a strictly positive value and the TX duration of "
+                          "the PSDU is greater than or equal to this threshold, we use an RTS/CTS "
+                          "handshake before sending the data frame.",
+                          TimeValue(Time{0}),
+                          MakeTimeAccessor(&WifiRemoteStationManager::m_rtsCtsTxDurationThresh),
+                          MakeTimeChecker())
             .AddAttribute(
                 "FragmentationThreshold",
                 "If the size of the PSDU is bigger than this value, we fragment it such that the "
@@ -245,14 +253,16 @@
 bool
 WifiRemoteStationManager::GetHtSupported() const
 {
-    return bool(m_wifiPhy->GetDevice()->GetHtConfiguration());
+    return (m_wifiPhy->GetDevice()->GetHtConfiguration() &&
+            m_wifiPhy->GetPhyBand() != WIFI_PHY_BAND_6GHZ);
 }
 
 bool
 WifiRemoteStationManager::GetVhtSupported() const
 {
     return (m_wifiPhy->GetDevice()->GetVhtConfiguration() &&
-            m_wifiPhy->GetPhyBand() != WIFI_PHY_BAND_2_4GHZ);
+            m_wifiPhy->GetPhyBand() != WIFI_PHY_BAND_2_4GHZ &&
+            m_wifiPhy->GetPhyBand() != WIFI_PHY_BAND_6GHZ);
 }
 
 bool
@@ -270,11 +280,8 @@
 bool
 WifiRemoteStationManager::GetLdpcSupported() const
 {
-    if (GetHtSupported())
+    if (auto htConfiguration = m_wifiPhy->GetDevice()->GetHtConfiguration())
     {
-        Ptr<HtConfiguration> htConfiguration = m_wifiPhy->GetDevice()->GetHtConfiguration();
-        NS_ASSERT(htConfiguration); // If HT is supported, we should have a HT configuration
-                                    // attached
         return htConfiguration->GetLdpcSupported();
     }
     return false;
@@ -283,15 +290,9 @@
 bool
 WifiRemoteStationManager::GetShortGuardIntervalSupported() const
 {
-    if (GetHtSupported())
+    if (auto htConfiguration = m_wifiPhy->GetDevice()->GetHtConfiguration())
     {
-        Ptr<HtConfiguration> htConfiguration = m_wifiPhy->GetDevice()->GetHtConfiguration();
-        NS_ASSERT(htConfiguration); // If HT is supported, we should have a HT configuration
-                                    // attached
-        if (htConfiguration->GetShortGuardIntervalSupported())
-        {
-            return true;
-        }
+        return htConfiguration->GetShortGuardIntervalSupported();
     }
     return false;
 }
@@ -863,7 +864,7 @@
             found = true;
         }
     }
-    if (GetHtSupported())
+    if (m_wifiPhy->GetDevice()->GetHtConfiguration())
     {
         if (!found)
         {
@@ -932,7 +933,7 @@
             found = true;
         }
     }
-    if (GetHtSupported())
+    if (m_wifiPhy->GetDevice()->GetHtConfiguration())
     {
         for (const auto& thismode : m_wifiPhy->GetMcsList())
         {
@@ -1119,12 +1120,11 @@
 }
 
 bool
-WifiRemoteStationManager::NeedRts(const WifiMacHeader& header, uint32_t size)
+WifiRemoteStationManager::NeedRts(const WifiMacHeader& header, const WifiTxParameters& txParams)
 {
-    NS_LOG_FUNCTION(this << header << size);
-    Mac48Address address = header.GetAddr1();
-    WifiTxVector txVector = GetDataTxVector(header, m_wifiPhy->GetChannelWidth());
-    const auto modulationClass = txVector.GetModulationClass();
+    NS_LOG_FUNCTION(this << header << &txParams);
+    auto address = header.GetAddr1();
+    const auto modulationClass = txParams.m_txVector.GetModulationClass();
     if (address.IsGroup())
     {
         return false;
@@ -1146,7 +1146,11 @@
         NS_LOG_DEBUG("WifiRemoteStationManager::NeedRTS returning true to protect non-HT stations");
         return true;
     }
-    bool normally = (size > m_rtsCtsThreshold);
+    NS_ASSERT(txParams.m_txDuration.has_value());
+    auto size = txParams.GetSize(header.GetAddr1());
+    bool normally =
+        (size > m_rtsCtsThreshold) || (m_rtsCtsTxDurationThresh.IsStrictlyPositive() &&
+                                       *txParams.m_txDuration >= m_rtsCtsTxDurationThresh);
     return DoNeedRts(Lookup(address), size, normally);
 }
 
@@ -1188,7 +1192,7 @@
                 return false;
             }
         }
-        if (GetHtSupported())
+        if (m_wifiPhy->GetDevice()->GetHtConfiguration())
         {
             // search for the BSS Basic MCS set, if the used mode is in the basic set then there is
             // no need for CTS To Self
@@ -1590,6 +1594,18 @@
 }
 
 void
+WifiRemoteStationManager::AddStationHe6GhzCapabilities(
+    const Mac48Address& from,
+    const He6GhzBandCapabilities& he6GhzCapabilities)
+{
+    // Used by all stations to record HE 6GHz band capabilities of remote stations
+    NS_LOG_FUNCTION(this << from << he6GhzCapabilities);
+    auto state = LookupState(from);
+    state->m_he6GhzBandCapabilities = Create<const He6GhzBandCapabilities>(he6GhzCapabilities);
+    SetQosSupport(from, true);
+}
+
+void
 WifiRemoteStationManager::AddStationEhtCapabilities(Mac48Address from,
                                                     EhtCapabilities ehtCapabilities)
 {
@@ -1642,6 +1658,12 @@
     return LookupState(from)->m_heCapabilities;
 }
 
+Ptr<const He6GhzBandCapabilities>
+WifiRemoteStationManager::GetStationHe6GhzCapabilities(const Mac48Address& from) const
+{
+    return LookupState(from)->m_he6GhzBandCapabilities;
+}
+
 Ptr<const EhtCapabilities>
 WifiRemoteStationManager::GetStationEhtCapabilities(Mac48Address from)
 {
@@ -1712,7 +1734,8 @@
 {
     NS_LOG_FUNCTION(this << st);
 
-    if (!GetHtSupported() || !GetHtSupported(st))
+    if ((!m_wifiPhy->GetDevice()->GetHtConfiguration()) ||
+        (!GetHtSupported(st) && !GetStationHe6GhzCapabilities(st->m_state->m_address)))
     {
         return GetDefaultMode();
     }
@@ -1983,10 +2006,14 @@
 uint8_t
 WifiRemoteStationManager::GetNumberOfSupportedStreams(const WifiRemoteStation* station) const
 {
-    Ptr<const HtCapabilities> htCapabilities = station->m_state->m_htCapabilities;
+    const auto htCapabilities = station->m_state->m_htCapabilities;
 
     if (!htCapabilities)
     {
+        if (const auto heCapabilities = station->m_state->m_heCapabilities)
+        {
+            return heCapabilities->GetHighestNssSupported();
+        }
         return 1;
     }
     return htCapabilities->GetRxHighestSupportedAntennas();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-remote-station-manager.h ns-3.42/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.41/src/wifi/model/wifi-remote-station-manager.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-remote-station-manager.h	2024-05-29 15:29:47.212073800 -0700
@@ -27,6 +27,7 @@
 
 #include "ns3/data-rate.h"
 #include "ns3/eht-capabilities.h"
+#include "ns3/he-6ghz-band-capabilities.h"
 #include "ns3/he-capabilities.h"
 #include "ns3/ht-capabilities.h"
 #include "ns3/mac48-address.h"
@@ -49,6 +50,7 @@
 class Packet;
 class WifiMpdu;
 class WifiTxVector;
+class WifiTxParameters;
 
 struct WifiRemoteStationState;
 struct RxSignalInfo;
@@ -111,6 +113,8 @@
     Ptr<const HtCapabilities> m_htCapabilities;   //!< remote station HT capabilities
     Ptr<const VhtCapabilities> m_vhtCapabilities; //!< remote station VHT capabilities
     Ptr<const HeCapabilities> m_heCapabilities;   //!< remote station HE capabilities
+    Ptr<const He6GhzBandCapabilities>
+        m_he6GhzBandCapabilities;                 //!< remote station HE 6GHz band capabilities
     Ptr<const EhtCapabilities> m_ehtCapabilities; //!< remote station EHT capabilities
     /// remote station Multi-Link Element Common Info
     std::shared_ptr<CommonInfoBasicMle> m_mleCommonInfo;
@@ -261,6 +265,14 @@
      */
     void AddStationHeCapabilities(Mac48Address from, HeCapabilities heCapabilities);
     /**
+     * Records HE 6 GHz Band Capabilities of a remote station
+     *
+     * \param from the address of the remote station
+     * \param he6GhzCapabilities the HE 6 GHz Band Capabilities of the remote station
+     */
+    void AddStationHe6GhzCapabilities(const Mac48Address& from,
+                                      const He6GhzBandCapabilities& he6GhzCapabilities);
+    /**
      * Records EHT capabilities of the remote station.
      *
      * \param from the address of the station being recorded
@@ -298,6 +310,13 @@
      */
     Ptr<const HeCapabilities> GetStationHeCapabilities(Mac48Address from);
     /**
+     * Return the HE 6 GHz Band Capabilities sent by a remote station.
+     *
+     * \param from the address of the remote station
+     * \return the HE 6 GHz Band capabilities sent by the remote station
+     */
+    Ptr<const He6GhzBandCapabilities> GetStationHe6GhzCapabilities(const Mac48Address& from) const;
+    /**
      * Return the EHT capabilities sent by the remote station.
      *
      * \param from the address of the remote station
@@ -317,13 +336,17 @@
     std::optional<std::reference_wrapper<CommonInfoBasicMle::MldCapabilities>>
     GetStationMldCapabilities(const Mac48Address& from);
     /**
-     * Return whether the device has HT capability support enabled.
+     * Return whether the device has HT capability support enabled on the link this manager is
+     * associated with. Note that this means that this function returns false if this is a
+     * 6 GHz link.
      *
      * \return true if HT capability support is enabled, false otherwise
      */
     bool GetHtSupported() const;
     /**
-     * Return whether the device has VHT capability support enabled.
+     * Return whether the device has VHT capability support enabled on the link this manager is
+     * associated with. Note that this means that this function returns false if this is a
+     * 2.4 or 6 GHz link.
      *
      * \return true if VHT capability support is enabled, false otherwise
      */
@@ -955,13 +978,13 @@
     void ReportRxOk(Mac48Address address, RxSignalInfo rxSignalInfo, WifiTxVector txVector);
 
     /**
-     * \param header MAC header
-     * \param size the size of the frame to send in bytes
+     * \param header MAC header of the data frame to send
+     * \param txParams the TX parameters for the data frame to send
      *
      * \return true if we want to use an RTS/CTS handshake for this
      *         frame before sending it, false otherwise.
      */
-    bool NeedRts(const WifiMacHeader& header, uint32_t size);
+    bool NeedRts(const WifiMacHeader& header, const WifiTxParameters& txParams);
     /**
      * Return if we need to do CTS-to-self before sending a DATA.
      *
@@ -1494,6 +1517,7 @@
     uint32_t m_maxSsrc;                //!< Maximum STA short retry count (SSRC)
     uint32_t m_maxSlrc;                //!< Maximum STA long retry count (SLRC)
     uint32_t m_rtsCtsThreshold;        //!< Threshold for RTS/CTS
+    Time m_rtsCtsTxDurationThresh;     //!< TX duration threshold for RTS/CTS
     uint32_t m_fragmentationThreshold; //!< Current threshold for fragmentation
     uint8_t m_defaultTxPowerLevel;     //!< Default transmission power level
     WifiMode m_nonUnicastMode;         //!< Transmission mode for non-unicast Data frames
